/*
 * $Id$
 */

package org.apache.maven.continuum.model.project;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.*;
import org.apache.maven.continuum.model.scm.ChangeFile;
import org.apache.maven.continuum.model.scm.ChangeSet;
import org.apache.maven.continuum.model.scm.ScmResult;
import org.apache.maven.continuum.model.system.ContinuumUser;
import org.apache.maven.continuum.model.system.Installation;
import org.apache.maven.continuum.model.system.NotificationAddress;
import org.apache.maven.continuum.model.system.Permission;
import org.apache.maven.continuum.model.system.SystemConfiguration;
import org.apache.maven.continuum.model.system.UserGroup;

/**
 * Class Profile.
 * 
 * @version $Revision$ $Date$
 */
public class Profile implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field id
     */
    private int id = 0;

    /**
     * Field active
     */
    private boolean active = false;

    /**
     * Field name
     */
    private String name;

    /**
     * Field description
     */
    private String description;

    /**
     * Field scmMode
     */
    private int scmMode = 0;

    /**
     * Field buildWithoutChanges
     */
    private boolean buildWithoutChanges = false;

    /**
     * Field jdk
     */
    private Installation jdk;

    /**
     * Field builder
     */
    private Installation builder;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method equals
     * 
     * @param other
     */
    public boolean equals(Object other)
    {
        if ( this == other)
        {
            return true;
        }
        
        if ( !(other instanceof Profile) )
        {
            return false;
        }
        
        Profile that = (Profile) other;
        return this.id== that.getId();
    } //-- boolean equals(Object) 

    /**
     * Method getBuilder
     */
    public Installation getBuilder()
    {
        return this.builder;
    } //-- Installation getBuilder() 

    /**
     * Method getDescription
     */
    public String getDescription()
    {
        return this.description;
    } //-- String getDescription() 

    /**
     * Method getId
     */
    public int getId()
    {
        return this.id;
    } //-- int getId() 

    /**
     * Method getJdk
     */
    public Installation getJdk()
    {
        return this.jdk;
    } //-- Installation getJdk() 

    /**
     * Method getName
     */
    public String getName()
    {
        return this.name;
    } //-- String getName() 

    /**
     * Method getScmMode
     */
    public int getScmMode()
    {
        return this.scmMode;
    } //-- int getScmMode() 

    /**
     * Method hashCode
     */
    public int hashCode()
    {
        long tmp;
        return (int) id;
    } //-- int hashCode() 

    /**
     * Method isActive
     */
    public boolean isActive()
    {
        return this.active;
    } //-- boolean isActive() 

    /**
     * Method isBuildWithoutChanges
     */
    public boolean isBuildWithoutChanges()
    {
        return this.buildWithoutChanges;
    } //-- boolean isBuildWithoutChanges() 

    /**
     * Method setActive
     * 
     * @param active
     */
    public void setActive(boolean active)
    {
        this.active = active;
    } //-- void setActive(boolean) 

    /**
     * Method setBuildWithoutChanges
     * 
     * @param buildWithoutChanges
     */
    public void setBuildWithoutChanges(boolean buildWithoutChanges)
    {
        this.buildWithoutChanges = buildWithoutChanges;
    } //-- void setBuildWithoutChanges(boolean) 

    /**
     * Method setBuilder
     * 
     * @param builder
     */
    public void setBuilder(Installation builder)
    {
        this.builder = builder;
    } //-- void setBuilder(Installation) 

    /**
     * Method setDescription
     * 
     * @param description
     */
    public void setDescription(String description)
    {
        this.description = description;
    } //-- void setDescription(String) 

    /**
     * Method setId
     * 
     * @param id
     */
    public void setId(int id)
    {
        this.id = id;
    } //-- void setId(int) 

    /**
     * Method setJdk
     * 
     * @param jdk
     */
    public void setJdk(Installation jdk)
    {
        this.jdk = jdk;
    } //-- void setJdk(Installation) 

    /**
     * Method setName
     * 
     * @param name
     */
    public void setName(String name)
    {
        this.name = name;
    } //-- void setName(String) 

    /**
     * Method setScmMode
     * 
     * @param scmMode
     */
    public void setScmMode(int scmMode)
    {
        this.scmMode = scmMode;
    } //-- void setScmMode(int) 

}
